/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2003 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 *  Copyright (C) 2002-2004 by Hokkaido Industrial Research Institute, JAPAN
 *  Copyright (C) 2006-2006 by Nobuhiro Sakawa
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 */

/*
 *   Xen ꥢ륳ߥ˥󥤥󥿥եɥ饤
 */

#include <s_services.h>
#include "xen_serial.h"

/*
 * ꥢI/OݡȽ֥å
 */
const SIOPINIB siopinib_table[TNUM_PORT] = {
	{0xffff81a0, 0/*BPS9600*/, 0x0, 6}, /* SCI0 */
};

/*
 *  ꥢI/Oݡȴ֥åΥꥢ
 */
static SIOPCB siopcb_table[TNUM_PORT];

/*
 *  ꥢI/OݡID֥åФΥޥ
 */
				/*  ݡIDǥХֹޥ  */
#define INDEX_SIOP(siopid)	((UINT)((siopid) - 1))
#define get_siopcb(siopid)	(&(siopcb_table[INDEX_SIOP(siopid)]))
#define TNUM_SIOP 1


/*
 *  SIOɥ饤Фν롼
 */
void
xen_con_initialize ()
{
	SIOPCB *siopcb;
	UINT i;
//printk("xen_con_initialize\n");
	/*
	 *  ꥢI/Oݡȴ֥åν
	 */
	for (siopcb = siopcb_table, i = 0; i < TNUM_SIOP; siopcb++, i++) {
		siopcb->openflag = FALSE;
	}

}

/*
 *  ץ󤷤ƤݡȤ뤫
 */
BOOL
xen_con_openflag (ID siopid)
{
//printk("xen_con_openflag\n");
	return(siopcb_table[0].openflag);
}

/*
 *  ꥢI/OݡȤΥץ
 */
SIOPCB *
xen_con_opn_por (ID siopid, VP_INT exinf)
{
	SIOPCB *siopcb = get_siopcb (siopid);
//printk("xen_con_opn_por\n");
	siopcb->exinf = exinf;
	siopcb->openflag = TRUE;
	return (siopcb);
}

/*
 *  ꥢI/OݡȤΥ
 */
void
xen_con_cls_por (SIOPCB * siopcb)
{
printk("xen_con_cls_por\n");
	/*  ߡ߶ػ  */
	siopcb->openflag = FALSE;
}

/*
 *  ꥢI/OݡȤؤʸ
 */
BOOL
xen_con_snd_chr (SIOPCB * siopcb, char c)
{
	printk("%c",c);
	return (TRUE);
}

/*
 *  ꥢI/OݡȤʸ
 */
INT
xen_con_rcv_chr (SIOPCB * siopcb)
{
	printk("xen_con_rcv_chr \n");
	return (0x41);
}

/*
 *  ꥢI/OݡȤΥХåε
 */
void
xen_con_ena_cbr (SIOPCB * siopcb, UINT cbrtn)
{
//	printk("xen_con_ena_cbr \n");
}

/*
 *  ꥢI/OݡȤΥХåζػ
 */
void
xen_con_dis_cbr (SIOPCB * siopcb, UINT cbrtn)
{
	printk("xen_con_dis_cbr \n");
}


/*
 *  ߥӥ롼
 *  
 */
void
xen_con_isr (void)
{
}

