/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2000-2003 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 *  Copyright (C) 2002-2004 by Hokkaido Industrial Research Institute, JAPAN
 *  Copyright (C) 2006	Nobuhiro Sakawa
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 */

/*
 *   Xenꥢ륳ߥ˥󥤥󥿥եɥ饤
 */

#ifndef _xen_serial_H_
#define _xen_serial_H_

#include <t_config.h>

/*
 *  ꥢI/OݡȽ֥å
 */
typedef struct sio_port_initialization_block
{
	UW reg_base;			/* 쥸Υ١ɥ쥹 */
	UB brr;				/* ܡ졼Ȥ   */
	UB smr;				/* ⡼ɥ쥸   */
	UB int_level;			/* ߥ٥   */
} SIOPINIB;

/*
 *  ꥢI/Oݡȴ֥å
 */
typedef struct sio_port_control_block
{
	const SIOPINIB *siopinib;	/* ꥢI/OݡȽ֥å */
	VP_INT exinf;			/* ĥ */
	BOOL openflag;			/* ץѤߥե饰 */
	BOOL sendflag;			/* ߥ֥͡ե饰 */
	BOOL getready;			/* ʸ */
	BOOL putready;			/* ʸǤ */
} SIOPCB;


/*
 *  SIOɥ饤Фν롼
 */
extern void xen_con_initialize (void);

/*
 *  ץ󤷤ƤݡȤ뤫
 */
extern BOOL xen_con_openflag (ID siopid);

/*
 *  ꥢI/OݡȤΥץ
 */
extern SIOPCB *xen_con_opn_por (ID siopid, VP_INT exinf);

/*
 *  ꥢI/OݡȤΥ
 */
extern void xen_con_cls_por (SIOPCB * siopcb);

/*
 *  ꥢI/OݡȤؤʸ
 */
extern BOOL xen_con_snd_chr (SIOPCB * siopcb, char c);

/*
 *  ꥢI/OݡȤʸ
 */
extern INT xen_con_rcv_chr (SIOPCB * siopcb);

/*
 *  ꥢI/OݡȤΥХåε
 */
extern void xen_con_ena_cbr (SIOPCB * siopcb, UINT cbrtn);

/*
 *  ꥢI/OݡȤΥХåζػ
 */
extern void xen_con_dis_cbr (SIOPCB * siopcb, UINT cbrtn);

/*
 *  SIOγߥӥ롼
 */
extern void xen_con_isr (void);

/*
 *  ꥢI/OݡȤǽХå
 */
extern void xen_con_ierdy_snd (VP_INT exinf);

/*
 *  ꥢI/OݡȤμΥХå
 */
extern void xen_con_ierdy_rcv (VP_INT exinf);

#endif /* _xen_serial_H_ */
